
Base Language - Bug #4108

CLIENT-PRINCIPAL:EXPORT-PRINCIPAL method quirk (4GL bug?)

06/07/2019 06:24 AM - Igor Skornyakov

Status: New Start date: 06/07/2019

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0.00 hour

Target version:    

billable: No case_num:  

vendor_id: GCD version:  

Description

Related issues:

Related to Base Language - Feature #3810: SECURITY-POLICY and other security ... Closed

History

#1 - 06/07/2019 06:28 AM - Igor Skornyakov

- File export-cp-bug.p added

I've noticed a strange side effect of the CLIENT-PRINCIPAL:EXPORT-PRINCIPAL method call.

If we run the attached export-cp-bug.p program the values of the attributes look empty (while in the serialized data they present).

If we comment out the EXPORT-PRINCIPAL() invocation, the result is as expected.

#2 - 06/07/2019 06:37 AM - Igor Skornyakov

- Description updated

#3 - 06/07/2019 06:38 AM - Igor Skornyakov

- File deleted (export-cp-bug.p)

#4 - 06/07/2019 06:53 AM - Igor Skornyakov

- Parent task deleted (#3810)

#5 - 06/07/2019 06:53 AM - Igor Skornyakov

- Related to Feature #3810: SECURITY-POLICY and other security features added

#6 - 06/08/2019 06:07 AM - Igor Skornyakov

More detailed info:

If after EXPORT-PRINCIPAL invocation any of the attributes are re-assigned then the order of attributes' values in the serialized data is changed (the

changed attribute's value goes to the end) and all attributes' values are returned as empty while present in the serialized form. This looks even

consistent and is possible to reproduce in FWD. This also applies to the assigning the value of the QUALIFIED-USER-ID which effectively changes

the values of USER-ID and DOMAIN-NAME (in this order).

Please note that it is impossible to "reset" CLIENT-PRINCIPAL attributes' values by assignment (except LOGIN-EXPIRATION-TIMESTAMP)- the

UNKNOWN value is either rejected or silently ignored if the attribute was assigned. One should use INITIALIZE to reset the CLIENT-PRINCIPAL

state.
Files

export-cp-bug.p 420 Bytes 06/07/2019 Igor Skornyakov
